{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Column Edit Dialog Unit                                           }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Columndlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Dlghead, StdCtrls, ExtCtrls, CheckLst;

type
  TColumnDialog = class(TForm)
    HeaderFrame1: THeaderFrame;
    Panel1: TPanel;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    Button1: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  ColumnDialog: TColumnDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst;

procedure TColumnDialog.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  s: string;
begin
  s :=  '';
  if  (SameText(ListBox1.Items[Index], 'UPDATE'))  then  begin
    s :=  'VEXV';
  end else
  if  (SameText(ListBox1.Items[Index], 'INFO'))  then  begin
    s :=  'ǁECɓo^';
  end else
  if  (SameText(ListBox1.Items[Index], 'PRIORITY'))  then  begin
    s :=  'dvx';
  end else
  if  (SameText(ListBox1.Items[Index], 'TITLE'))  then  begin
    s :=  '^Cg';
  end else
  if  (SameText(ListBox1.Items[Index], 'READPOINT'))  then  begin
    s :=  '܂œǂ';
  end else
  if  (SameText(ListBox1.Items[Index], 'READPOINTNO'))  then  begin
    s :=  '܂œǂ񂾂̃Xԍ';
  end else
  if  (SameText(ListBox1.Items[Index], 'AGECOUNT'))  then  begin
    s :=  'X(fł̃X)';
  end else
  if  (SameText(ListBox1.Items[Index], 'NEWCOUNT'))  then  begin
    s :=  'VX';
  end else
  if  (SameText(ListBox1.Items[Index], 'RESCOUNT'))  then  begin
    s :=  '擾ς݃X';
  end else
  if  (SameText(ListBox1.Items[Index], 'LASTLOAD'))  then  begin
    s :=  'ŏIǂݍݓ';
  end else
  if  (SameText(ListBox1.Items[Index], 'LASTSENT'))  then  begin
    s :=  'ŏIݓ';
  end else
  if  (SameText(ListBox1.Items[Index], 'COMMENT'))  then  begin
    s :=  'Rg';
  end else
  if  (SameText(ListBox1.Items[Index], 'BOARD'))  then  begin
    s :=  '';
  end else
  if  (SameText(ListBox1.Items[Index], 'BBS'))  then  begin
    s :=  'BBS';
  end else
  if  (SameText(ListBox1.Items[Index], 'DAT'))  then  begin
    s :=  'DATԍ';
  end else
  if  (SameText(ListBox1.Items[Index], 'SINCE'))  then  begin
    s :=  'Xē';
  end;
  ListBox1.Canvas.TextRect(Rect, Rect.Left + 2,
                          (Rect.Top + ((Rect.Bottom - Rect.Top) - (Abs(ListBox1.Canvas.TextHeight(s)))) div 2), s);
end;

procedure TColumnDialog.FormCreate(Sender: TObject);
begin
  ListBox1.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_COLUMN);
end;

procedure TColumnDialog.Button3Click(Sender: TObject);
var
  i, n : integer;
begin
  n   :=  -1;
  for i :=  1 to  ListBox1.Items.Count - 1 do  begin
    if  (ListBox1.Selected[i]) then  begin
      ListBox1.Items.Move(i, i - 1);
      if  (n < 0) then  n :=  i - 1;
    end;
  end;
  if  (n > -1)  then  ListBox1.Selected[n]  :=  True;
end;

procedure TColumnDialog.Button4Click(Sender: TObject);
var
  i, n : integer;
begin
  n   :=  -1;
  for i :=  ListBox1.Items.Count - 2 downto  0 do  begin
    if  (ListBox1.Selected[i]) then  begin
      ListBox1.Items.Move(i, i + 1);
      if  (n < 0) then  n :=  i + 1;
    end;
  end;
  if  (n > -1)  then  ListBox1.Selected[n]  :=  True;
end;

procedure TColumnDialog.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TColumnDialog.Button1Click(Sender: TObject);
begin
  ListBox1.Items.SaveToFile(ZonuConfig.UsersPath + FILE_COLUMN);
  ModalResult :=  mrOk;
end;

end.
