{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 About Dialog Unit                                                 }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Aboutdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ValEdit, ExtCtrls, Menus;

type
  TAboutDialog = class(TForm)
    Button1: TButton;
    ScrollBox1: TScrollBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Bevel1: TBevel;
    BoardLoadCount: TLabel;
    Bevel2: TBevel;
    ThreadLoadCount: TLabel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    ResSendCount: TLabel;
    ResLoadCount: TLabel;
    PopupCloseCount: TLabel;
    NewThreadCount: TLabel;
    AppStartCount: TLabel;
    Label21: TLabel;
    Bevel10: TBevel;
    TotalTime: TLabel;
    Label10: TLabel;
    Image1: TImage;
    Shape1: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Timer1: TTimer;
    Image2: TImage;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    Label13: TLabel;
    Bevel8: TBevel;
    AvgTime: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  AboutDialog: TAboutDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, DateUtils, Clipbrd;


procedure TAboutDialog.FormCreate(Sender: TObject);
var
  n, hh, mm, ss : integer;
begin
  BoardLoadCount.Caption          :=  IntToStr(ZonuConfig.LoadBoardCount);
  ThreadLoadCount.Caption         :=  IntToStr(ZonuConfig.LoadThreadCount);
  ResLoadCount.Caption            :=  IntToStr(ZonuConfig.LoadResCount);
  ResSendCount.Caption            :=  IntToStr(ZonuConfig.SendCount);
  NewThreadCount.Caption          :=  IntToStr(ZonuConfig.NewThreadCount);
  PopupCloseCount.Caption         :=  IntToStr(ZonuConfig.ClosePageCount);
  AppStartCount.Caption           :=  IntToStr(ZonuConfig.AppStartCount);
  //AppEndCount.Caption             :=  IntToStr(ZonuConfig.AppEndCount);
  //AppAbendCount.Caption           :=  IntToStr(ZonuConfig.AppStartCount - ZonuConfig.AppEndCount - 1);
  ShortDateFormat:='yyyy/mm/dd'; 
  n   :=  ZonuConfig.WorkedTime;
  hh  :=  (n div (1000 * 60 * 60));
  mm  :=  (n div (1000 * 60)) - (hh * 60);
  ss  :=  (n div 1000) - (mm * 60) - (hh * 60 * 60);
  TotalTime.Caption               :=  Format('%d:%d:%d',[hh,mm,ss]);
  Label10.Caption                 :=  'Version ' + APP_MAJOR_VERSION;
  //
  n   :=  (n div DaysBetween(Now, ZonuConfig.StartDate));
  hh  :=  (n div (1000 * 60 * 60));
  mm  :=  (n div (1000 * 60)) - (hh * 60);
  ss  :=  (n div 1000) - (mm * 60) - (hh * 60 * 60);
  AvgTime.Caption               :=  Format('%d:%d:%d',[hh,mm,ss]);
end;

procedure TAboutDialog.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TAboutDialog.Timer1Timer(Sender: TObject);
  procedure SetLabel(const A,B : string);
  var
    i: integer;
  begin
    for i :=  0 to  15  do  begin
      Label11.Font.Color  :=  RGB(i * 17, i * 17, i * 17);
      Label12.Font.Color  :=  RGB(i * 17, i * 17, i * 17);
      Update;
      Application.ProcessMessages;
      Sleep(100);
    end;
    Label11.Caption  :=  A;
    Label12.Caption  :=  B;
    for i :=  15  downto  0 do  begin
      Label11.Font.Color  :=  RGB(i * 17, i * 17, i * 17);
      Label12.Font.Color  :=  RGB(i * 17, i * 17, i * 17);
      Update;
      Application.ProcessMessages;
      Sleep(70);
    end;
  end;
begin
  if  (Timer1.Tag > 60) then  Timer1.Tag  :=  0;
  case  Timer1.Tag  of
    0 : SetLabel('Design and Development','Dax');
    1 : SetLabel('Thanx','(q)');
    2 : SetLabel('Thanx','`҂');
    3 : SetLabel('Thanx','Twiddle');
    4 : SetLabel('Thanx','DLL/lGHE');
    5 : SetLabel('Thanx','ψ');
    6 : SetLabel('Thanx','turbo type D');
    7 : SetLabel('Thanx','DeltTMR');
    8 : SetLabel('Hotzonu Project','alec');
    9 : SetLabel('Hotzonu Project','WXG');
    10: SetLabel('Hotzonu Documents','K');
    11: SetLabel('Hotzonu Support Tools','');
    12: SetLabel('Hotzonu Support Tools','cera');
    13: SetLabel('Hotzonu Skin','؂ł[ނ');
    14: SetLabel('Hotzonu BBS','Rbp');
    15: SetLabel('Hotzonu FAQ','zonutan');
    16: SetLabel('Hotzonu Project','gyu');
    17: SetLabel('Hotzonu Project','킯');
    18: SetLabel('Hotzonu Project',' FmBLACK2');
    19: SetLabel('Hotzonu Project','HIROWrss');
    20: SetLabel('Hotzonu Project','肳');
    21: SetLabel('Hotzonu Project','apholist');
    22: SetLabel('Hotzonu Project','gali');
    24: SetLabel('Hotzonu Project','faker');
    23: SetLabel('Hotzonu Project','傭̂');
    25: SetLabel('Hotzonu Project','YBE');
    26: SetLabel('Hotzonu Project','RWRW');
    27: SetLabel('Hotzonu Project','iibV[');
    28: SetLabel('Hotzonu Project','KAZ');
    29: SetLabel('Hotzonu Project','kitaro');
    30: SetLabel('Hotzonu Project','NaNaC');
    31: SetLabel('Hotzonu Project','ParityBit');
    32: SetLabel('Hotzonu Project','uB ');
    33: SetLabel('Hotzonu Project','aliceride');
    34: SetLabel('Hotzonu Project','sute8');
    35: SetLabel('Hotzonu Project','kota');
    36: SetLabel('Hotzonu Project','eda');
    37: SetLabel('Hotzonu Project','');
    38: SetLabel('Hotzonu Project','Ƃ邳');
    39: SetLabel('Hotzonu Project','OMEGA');
    40: SetLabel('Hotzonu Project','V');
    41: SetLabel('Hotzonu Project','Nobuo');
    42: SetLabel('Hotzonu Project','shimada');
    43: SetLabel('Hotzonu Project','North');
    44: SetLabel('Hotzonu Project','q');
    45: SetLabel('Hotzonu Project','܏\');
    46: SetLabel('Hotzonu Project','c');
    47: SetLabel('Hotzonu Project','MASATO');
    48: SetLabel('Hotzonu Project','teilfiar');
    49: SetLabel('Thanx','kl');
    50: SetLabel('Hotzonu Support Tools','Picodon');


    51: SetLabel('Q˂Ǘl','Ђ䂫');

    52: SetLabel('Q˂IǗ','΂');
    53: SetLabel('ΊǗl','炳');
    54: SetLabel('megabbsǗl','chҎ҂');
    55: SetLabel('megabbsǗl','^qlY~');
    56: SetLabel('ттǗl','ӂ񂳂');
    57: SetLabel('212chǗl','Ky');
    58: SetLabel('MILKCAFEǗl','񂷂');
    59: SetLabel('݂̂fǗl','ۂ');
    60: SetLabel('','Monazilla Project');
  end;
  Timer1.Tag := Timer1.Tag + 1;
end;

procedure TAboutDialog.Copy1Click(Sender: TObject);
var
  s: string;
begin
  s :=  '̃[h񐔁@@@F' +  IntToStr(ZonuConfig.LoadBoardCount)   + #13#10  +
        'Xbh̃[h񐔁F' +  IntToStr(ZonuConfig.LoadThreadCount)  + #13#10  +
        'X̎擾@@@@F' +  IntToStr(ZonuConfig.LoadResCount)     + #13#10  +
        '݉񐔁@@@@F' +  IntToStr(ZonuConfig.SendCount)        + #13#10  +
        'Xĉ񐔁@@@@F' +  IntToStr(ZonuConfig.NewThreadCount)   + #13#10  +
        '}~|bvAbv@@F' +  IntToStr(ZonuConfig.ClosePageCount)   + #13#10  +
        'N񐔁@@@@@@F' +  IntToStr(ZonuConfig.AppStartCount)    + #13#10  +
        'ғԁ@@@@@F' +  TotalTime.Caption + #13#10 +
        'P̕ωғԁ@F' +  AvgTime.Caption;
  Clipboard.AsText :=  s;
end;

end.
